# AUTHOR:
#	Simon J. Gerraty <sjg@crufty.net>
#

# RCSid:
#	$Id: topN.pl,v 1.2 2001/08/30 09:56:00 sjg Exp $
#
#	@(#) Copyright (c) 1993 Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that 
#	the above copyright notice and this notice are
#	left intact. 
#      
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

# We rely on *A being set to the array being sorted...
sub revbyval {
  $A{$b} <=> $A{$a};
}

sub topN {
  local($heading, $n, *A, $fw, $func) = @_;
  
  $i = 1;
  $fw=48 if ($fw eq '');
  
  foreach $k (sort revbyval keys(%A)) {
    printf "\nTop %d %s:\n", $n, $heading if ($heading ne '' && $i == 1);
    if ($func ne '') {
      printf "%4d: %-${fw}.${fw}s %s\n", $i++, $k, &$func($A{$k});
    } else {
      printf "%4d: %-${fw}.${fw}s %d\n", $i++, $k, $A{$k};
    }
    last if ($n > 0 && $i > $n);
  }
}

1;
